<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import Card from "./lib/Card.svelte";
  import {
    Color,
    colors,
    getActivePlayerId,
    getCard,
    groupCards,
    groupCardsSorted,
  } from "./lib/game";
  import type { GroupedCards } from "./lib/game";
  import { last, orderPlayers, reversed, sorted, take } from "./lib/utils";

  import { crossfade } from "svelte/transition";
  import InvisibleCard from "./lib/InvisibleCard.svelte";
  import EmptyCardSlot from "./lib/EmptyCardSlot.svelte";
  import ColorIcon from "./lib/ColorIcon.svelte";
  import Scoreboard from "./lib/Scoreboard.svelte";
  import PhaseDescription from "./lib/PhaseDescription.svelte";

  const dispatch = createEventDispatcher();
  function performAction(action: Action) {
    dispatch("action", action);
  }

  const [send, receive] = crossfade({
    duration: (d) => Math.sqrt(d * 300),
  });

  export let state: GameState;
  export let playerId: PlayerId | null;
  export let settings: GameSettings;

  $: orderedPlayers = orderPlayers(state.players, playerId);
  $: activePlayerId = getActivePlayerId(state);

  function getPlayerStyle(playerIdx: number, isUser: boolean): string {
    if (playerIdx === 0) {
      return "--player-translate-y: -25rem;";
    } else if (!isUser) {
      return "--player-translate-y: 25rem;";
    }
    return "--player-translate-y: 28rem;";
  }

  let user: PlayerState | undefined;
  $: user = state.players.find((p) => p.id === playerId);

  let selectedCardId: CardId | null = null;
  $: if (selectedCardId && !user?.hand.includes(selectedCardId)) {
    selectedCardId = null;
  }

  let isDeckButtonEnabled = (
    userId: PlayerId | null,
    activePlayerId: PlayerId | null,
    phase: Phase
  ): boolean => {
    switch (phase.k) {
      case "Drawing":
        return userId !== null && userId === activePlayerId;
      default:
        return false;
    }
  };

  let handleDeckClick = (_: Event) => {
    performAction({ k: "Draw", v: [] });
  };

  let handleHandClick = (cardId: CardId) => (_: Event) => {
    if (selectedCardId === cardId) {
      selectedCardId = null;
    } else {
      selectedCardId = cardId;
    }
  };

  let isDiscardButtonEnabled = (
    userId: PlayerId | null,
    activePlayerId: PlayerId | null,
    phase: Phase,
    color: Color,
    selectedCardId: CardId | null
  ): boolean => {
    if (userId === null || userId !== activePlayerId) {
      return false;
    }

    switch (phase.k) {
      case "Placing":
        return (
          selectedCardId !== null && getCard(selectedCardId).color === color
        );
      default:
        return false;
    }
  };

  function handleDiscardClick(_: Event) {
    if (state.phase.k === "Placing" && selectedCardId !== null) {
      return performAction({ k: "Discard", v: selectedCardId });
    }
  }

  let isTakeButtonEnabled = (
    userId: PlayerId | null,
    activePlayerId: PlayerId | null,
    phase: Phase,
    color: Color,
    discardedCards: GroupedCards
  ): boolean => {
    if (userId === null || userId !== activePlayerId) {
      return false;
    }

    switch (phase.k) {
      case "Drawing":
        let cards = discardedCards[color];
        return cards.length > 0 && cards[0].id !== phase.v.discarded;
      default:
        return false;
    }
  };

  let handleTakeClick = (color: Color) => (_: Event) => {
    if (state.phase.k === "Drawing") {
      return performAction({ k: "Take", v: color });
    }
  };

  let isPlaceButtonEnabled = (
    userId: PlayerId | null,
    activePlayerId: PlayerId | null,
    phase: Phase,
    color: Color,
    selectedCardId: CardId | null,
    placedCards: GroupedCards
  ): boolean => {
    if (userId === null || userId !== activePlayerId) return false;

    if (selectedCardId === null) return false;

    let selectedCard = getCard(selectedCardId);

    if (selectedCard.color !== color) return false;

    switch (phase.k) {
      case "Placing":
        const previouslyPlaced = last(placedCards[color]);
        return (
          !previouslyPlaced ||
          previouslyPlaced.value === "x" ||
          selectedCard.value > previouslyPlaced.value
        );

      default:
        return false;
    }
  };

  function handlePlaceClick(_: Event): void {
    if (selectedCardId !== null) {
      performAction({ k: "Place", v: selectedCardId });
    }
  }

  let isPlayerCardButtonEnabled = (
    userId: PlayerId | null,
    playerId: PlayerId,
    activePlayerId: PlayerId | null,
    phase: Phase
  ): boolean => {
    switch (phase.k) {
      case "Placing":
        return playerId === userId && playerId == activePlayerId;
      default:
        return false;
    }
  };

  $: colorGridClass = settings.sixColors ? "six-colors" : "five-colors";

  $: opponentPlacedCards = groupCardsSorted(orderedPlayers[0].placed);
  $: discardedCards = groupCards(state.discarded);
  $: placedCards = groupCardsSorted(orderedPlayers[1].placed);
</script>

<div class="wrapper">
  <div class="board">
    <div class="opponent-placed {colorGridClass}">
      {#each colors(settings) as color (color)}
        <div class="opponent-placed-column">
          {#each opponentPlacedCards[color] as card (card.id)}
            <div class="opponent-placed-card">
              <div in:receive={{ key: card.id }} out:send={{ key: card.id }}>
                <Card cardId={card.id} />
              </div>
            </div>
          {/each}
        </div>
      {/each}
    </div>

    <div class="discarded panel {colorGridClass}">
      {#each colors(settings) as color (color)}
        <div class="discarded-column">
          {#if discardedCards[color].length === 0}
            <div
              class="discarded-card discarded-placeholder"
              style="--card-index: 0;"
            >
              <EmptyCardSlot>
                <div class="discarded-placeholder-icon">
                  <ColorIcon {color} />
                </div>
              </EmptyCardSlot>
            </div>
          {/if}

          {#each reversed(discardedCards[color]) as card, i (card.id)}
            <div class="discarded-card" style="--card-index: {i};">
              <div in:receive={{ key: card.id }} out:send={{ key: card.id }}>
                <Card cardId={card.id} />
              </div>
            </div>
          {/each}

          <div
            class="discarded-card"
            style="
              --card-index: {Math.max(discardedCards[color].length - 1, 0)};
              "
          >
            <InvisibleCard>
              {#if state.phase.k === "Drawing"}
                <button
                  class="take-card ring-button"
                  type="button"
                  disabled={!isTakeButtonEnabled(
                    playerId,
                    activePlayerId,
                    state.phase,
                    color,
                    discardedCards
                  )}
                  on:click|preventDefault={handleTakeClick(color)}
                  aria-label="take"
                />
              {:else if state.phase.k === "Placing"}
                <button
                  class="discard-card ring-button"
                  type="button"
                  disabled={!isDiscardButtonEnabled(
                    playerId,
                    activePlayerId,
                    state.phase,
                    color,
                    selectedCardId
                  )}
                  on:click|preventDefault={handleDiscardClick}
                  aria-label="discard"
                />
              {/if}
            </InvisibleCard>
          </div>
        </div>
      {/each}

      <div class="deck">
        {#if state.deck.length > 0}
          {#each reversed(take(5, state.deck)) as cardId, i (cardId)}
            <div class="deck-card" style="--card-index: {i};">
              <div out:send={{ key: cardId }}>
                <Card {cardId} faceDown />
              </div>
            </div>
          {/each}
          <div
            class="deck-card"
            style="
          --card-index: {Math.max(take(5, state.deck).length - 1, 0)}
      "
          >
            <InvisibleCard>
              <button
                class="draw-card-button ring-button"
                type="button"
                disabled={!isDeckButtonEnabled(
                  playerId,
                  activePlayerId,
                  state.phase
                )}
                on:click|preventDefault={handleDeckClick}
              />

              <div class="deck-count">
                &times; {state.deck.length}
              </div>
            </InvisibleCard>
          </div>
        {/if}
      </div>

      <div class="phase-description">
        <PhaseDescription phase={state.phase} {user} />
      </div>
    </div>

    <div class="placed {colorGridClass}">
      {#each colors(settings) as color (color)}
        <div class="placed-column">
          {#each placedCards[color] as card (card.id)}
            <div class="placed-card">
              <div in:receive={{ key: card.id }} out:send={{ key: card.id }}>
                <Card cardId={card.id} />
              </div>
            </div>
          {/each}
          <div class="placed-card">
            <InvisibleCard>
              <button
                class="place-button ring-button"
                type="button"
                disabled={!isPlaceButtonEnabled(
                  playerId,
                  activePlayerId,
                  state.phase,
                  color,
                  selectedCardId,
                  placedCards
                )}
                on:click|preventDefault={handlePlaceClick}
                aria-label="place"
              />
            </InvisibleCard>
          </div>
        </div>
      {/each}
    </div>
  </div>

  <div class="players">
    {#each state.players as player (player.id)}
      <div
        class="player-outer"
        style={getPlayerStyle(
          orderedPlayers.findIndex((p) => p.id === player.id),
          player.id === playerId
        )}
      >
        <div class="player-inner">
          {#each player.id === playerId ? sorted(player.hand) : player.hand as cardId, i (cardId)}
            <button
              type="button"
              class:opponent={playerId === null || playerId !== player.id}
              class={`${cardId === selectedCardId ? "selected" : ""} card`}
              disabled={!isPlayerCardButtonEnabled(
                playerId,
                player.id,
                activePlayerId,
                state.phase
              )}
              on:click={handleHandClick(cardId)}
              style="
                --card-index: {i};
                --card-index-offset: {(player.hand.length - 1) / 2};
              "
            >
              <div in:receive={{ key: cardId }} out:send={{ key: cardId }}>
                <Card
                  {cardId}
                  faceDown={playerId === null || playerId !== player.id}
                />
              </div>
            </button>
          {/each}
          <gs6-player-box
            userid={player.id}
            active={player.id === activePlayerId}
          />
        </div>
      </div>
    {/each}
  </div>

  {#if state.phase.k === "Complete"}
    <div class="scoreboard panel">
      <Scoreboard {settings} {state} />
    </div>
  {/if}
</div>

<style>
  .wrapper :global(button:disabled) {
    pointer-events: none;
  }

  .board {
    font-size: 0.9em;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    display: grid;
    grid-template-rows: 1fr 10rem 1fr;
  }

  .opponent-placed {
    padding-left: 1em;
    padding-right: 1em;
    margin-bottom: 0.5em;
  }

  .opponent-placed-column {
    display: flex;
    flex-direction: column-reverse;
  }
  .opponent-placed-card:not(:first-child) {
    margin-bottom: -56.5%;
  }
  .opponent-placed-card:not(:last-child) {
    margin-top: -56.5%;
  }

  .discarded {
    position: relative;
    background-color: linen;
  }
  .discarded-column {
    width: 5em;
    position: relative;
  }
  .discarded-placeholder {
    filter: opacity(67%);
  }
  .discarded-placeholder-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) scale(2);
  }
  .discarded-card {
    position: absolute;
    top: 50%;
    left: 50%;

    transform: translate(-50%, -50%)
      translate(
        calc(var(--card-index) * -0.1em),
        calc(var(--card-index) * -0.1em)
      );
  }

  .phase-description {
    position: absolute;
    bottom: 0.25em;
    left: 50%;
    transform: translateX(-50%);
    white-space: nowrap;
    font-style: oblique;
    font-weight: 300;
  }

  button.ring-button {
    width: 3.5em;
    height: 3.5em;
    border: none;
    border-radius: 50%;

    box-shadow: 0 0 0 5px #1786ec8f;
    background-color: transparent;

    transition: opacity 0.25s;
  }
  button.ring-button:disabled {
    opacity: 0;
  }

  button.take-card,
  button.discard-card {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .placed {
    margin-top: 0.5em;
    padding-left: 1em;
    padding-right: 1em;
  }
  .placed-column {
    display: flex;
    flex-direction: column;
  }
  .placed-card:not(:first-child) {
    margin-top: -56.5%;
  }
  .placed-card:not(:last-child) {
    margin-bottom: -56.5%;
  }
  button.place-button {
    position: absolute;
    top: 0.5em;
    left: 50%;
    transform: translateX(-50%);
  }

  .deck {
    position: absolute;
    top: 50%;
    right: -1rem;
    transform: translate(100%, -50%);

    display: grid;
    grid-template-columns: auto auto;
    place-items: center;
    gap: 0.5em;
  }

  .deck-count {
    position: absolute;
    bottom: 0.15em;
    right: 0.15em;

    transform: translate(0, 0);
    font-size: 125%;
    font-weight: 500;
    color: white;
    filter: drop-shadow(0 0 1px #000);

    line-height: 1;
    white-space: nowrap;
    padding: 0.1em 0.2em;

    border-radius: 2px;
    background-color: #0003;
  }

  .draw-card-button {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
  .deck-card:not(:first-child) {
    position: absolute;
    top: 0;
    left: 0;
    transform: translate(
      calc(var(--card-index) * -0.1em),
      calc(var(--card-index) * -0.1em)
    );
  }

  .six-colors {
    display: grid;
    gap: 1em;
    grid-template-columns: repeat(6, 1fr);
  }
  .five-colors {
    display: grid;
    gap: 1em;
    grid-template-columns: repeat(5, 1fr);
  }

  .player-outer {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(var(--player-translate-y));

    transition: transform 0.5s;
  }
  .player-inner {
    position: relative;
  }

  .card {
    border: none;
    font: inherit;
    padding: 0;
    background: none;
    text-align: inherit;

    --card-translate-y: 0;

    position: absolute;
    top: -1em;
    left: 50%;
    transform-origin: center 50em;
    transform: translate(-50%, -50%)
      rotate(calc((var(--card-index) - var(--card-index-offset)) * 2.5deg))
      translateY(var(--card-translate-y));

    transition: transform 0.2s;
  }

  .card.opponent {
    font-size: 0.67em;
  }
  button:not(:disabled) {
    cursor: pointer;
  }
  button:disabled {
    color: inherit;
  }

  .card:hover:not(:disabled):not(.selected),
  .card:focus-within:not(:disabled):not(.selected) {
    --card-translate-y: -0.75em;
  }

  .card.selected {
    box-shadow: 0 0 0 4px #1786ec8f;
    border-radius: 4px;
    --card-translate-y: -1.25em;
  }

  .scoreboard {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
